/***************************************************************************\
  "indentstack.h" - Indent Scope Stack (Phase E)
  Revision 1; 6 Dec 2002 - 6 Dec 2002
  Copyright (C) 2002  Kevin P. Albrecht
\***************************************************************************/

#ifndef INDENTSTACK_H
#define INDENTSTACK_H

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //

/////////////////////////
// DECLARATIONS /////////
/////////////////////////

// External //
typedef struct IndentStackElement_tag
{
  int indent;
  struct IndentStackElement_tag *next;
} IndentStackElement;

IndentStackElement *indentstack_top;
int indentstack_count;

void indentstack_init ();
void indentstack_deinit ();
void indentstack_push (int aIndent);
int  indentstack_pop ();
int  indentstack_peek ();

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

void indentstack_init ()
{
  indentstack_top = NULL;
  indentstack_count = 0;
}

void indentstack_deinit ()
{
  IndentStackElement *temp;

  while (indentstack_top != NULL)
  {
    temp = indentstack_top;
    indentstack_top = indentstack_top->next;
    free (temp);
  }
}

void indentstack_push (int aIndent)
{
  IndentStackElement *temp;

  temp = indentstack_top;
  indentstack_top = (IndentStackElement *) malloc (sizeof (IndentStackElement));
  indentstack_top->indent = aIndent;
  indentstack_top->next = temp;

  indentstack_count++;
}

// returns 0 if stack empty //
int indentstack_pop ()
{
  IndentStackElement *temp;
  int ntemp;

  if (indentstack_top != NULL)
  {
    temp = indentstack_top;
    indentstack_top = indentstack_top->next;
    indentstack_count--;
    ntemp = temp->indent;
    free (temp);
    return ntemp;
  }
  else
  {
    return 0;
  }
}

// returns 0 if stack empty //
int indentstack_peek ()
{
  if (indentstack_top != NULL)
  {
    return indentstack_top->indent;
  }
  else
  {
    return 0;
  }
}

#endif

